From ae81c3719ae5e196640bb267d558471973c7f58a Mon Sep 17 00:00:00 2001
From: Kamil Páral <kparal@redhat.com>
Date: May 16 2018 13:55:56 +0000
Subject: [PATCH 6/7] add tests. Also add back option to run non-root, since tests need it


---

diff --git a/libtaskotron/executor.py b/libtaskotron/executor.py
index 4cb795e..158c18d 100644
--- a/libtaskotron/executor.py
+++ b/libtaskotron/executor.py
@@ -71,8 +71,8 @@ class Executor(object):
         '''Spawn a virtual machine using testcloud.
 
         :param str uuid: unicode string uuid for the task being executed
-        :param dict playbook_vars: a vars dict based on
-            :const:`_PLAYBOOK_VARS_TEMPLATE`
+        :param dict playbook_vars: a vars dict created by
+            :meth:`_create_playbook_vars`
         :returns: str ip address of spawned vm
         '''
         log.info('Spawning disposable client')
@@ -161,85 +161,96 @@ class Executor(object):
                       e)
             raise exc.TaskotronPlaybookError(e)
 
-    def _create_playbook_vars(self, test_playbook):
-        '''Create and return dictionary containing all variables to be used
-        with our ansible playbook. The dictionary contains these keys:
-
-        artifacts_root
-          path to the root artifacts directory (on overlord and minion)
-
-        artifacts
-          path to the playbook-specific artifacts directory (on overlord and
-          minion)
-
-        client_taskdir
-          path to directory with test suite (on minion)
-
-        exec_tasks
-          path to taskotron tasks playbook (generic or STI)
-
-        heartbeat_file
-          heartbeat will appear in this file
-
-        heartbeat_interval
-          add line to heartbeat_file every x seconds (2 minutes)
-
-        local
-          running on local machine (overlord), no remote connection
-
-        minion_repos
-          a list of repos (strings) to install on the minion
-
-        sti_inventory
-          path to inventory file to be used with STI tests (local inside
-          client_taskdir or global)
-
-        taskdir
-          path to directory with test suite (on overlord)
+    def _load_playbook_vars(self, test_playbook):
+        '''Load accepted playbook vars from a playbook file and return it
+        as a dict.
 
-        taskotron_arch
-          architecture of taskotron_item to be tested
-
-        taskotron_generic_task
-          whether to run a generic or STI task
-
-        taskotron_item_type
-          item under test
-
-        taskotron_item
-          item type under test
-
-        taskotron_keepalive_minutes
-          how long should heartbeat process run (0 to disable)
-
-        taskotron_match_host_arch
-          whether VM guest arch has to match taskotron_arch
-
-        taskotron_match_host_distro
-          whether VM guest distro has to match taskotron_item
-
-        taskotron_match_host_release
-          whether VM guest release has to match taskotron_item
-
-        taskotron_supported_arches
-          list of base architectures supported by Taskotron (e.g. 'armhfp')
-
-        taskotron_supported_binary_arches
-          list of base+binary architectures supported by Taskotron (e.g.
-          'armhfp, armv7hl')
+        :param str test_playbook: name of the playbook, relative to the task
+            directory
+        :return: a dict with keyvals from the playbook which are allowed to be
+            loaded (see :attr:`ACCEPTED_VARS`).
+        '''
+        vars_ = {}
+        with open(os.path.join(self.arg_data['taskdir'], test_playbook), 'r') \
+        as playbook_file:
+            playbook_yaml = yaml.safe_load(playbook_file.read())
+            # we only consider variables in the first play
+            playbook_vars = playbook_yaml[0].get('vars', {})
+        for var, val in playbook_vars.items():
+            if var in self.ACCEPTED_VARS:
+                vars_[var] = val
+        return vars_
 
-        test_playbook
-          path to playbook to execute inside client_taskdir (usually tests.yml)
+    def _create_playbook_vars(self, test_playbook):
+        '''Create and return dictionary containing all variables to be used
+        with our ansible playbook.
 
-        varsfile
-          name of the ansible vars file inside artifacts/taskotron/ to forward
-          to task
+        :param str test_playbook: name of the playbook, relative to the task
+            directory
+        :param bool root: whether to run playbooks as root. This is mainly
+            for testing purposes.
+
+        :return: A dictionary containing these keys:
+
+            artifacts_root
+                path to the root artifacts directory (on overlord and minion)
+            artifacts
+                path to the playbook-specific artifacts directory (on overlord
+                and minion)
+            become_root
+                whether to run playbooks as root
+            client_taskdir
+                path to directory with test suite (on minion)
+            exec_tasks
+                path to taskotron tasks playbook (generic or STI)
+            heartbeat_file
+                heartbeat will appear in this file
+            heartbeat_interval
+                add line to heartbeat_file every x seconds (2 minutes)
+            local
+                running on local machine (overlord), no remote connection
+            minion_repos
+                a list of repos (strings) to install on the minion
+            sti_inventory
+                path to inventory file to be used with STI tests (local inside
+                client_taskdir or global)
+            taskdir
+                path to directory with test suite (on overlord)
+            taskotron_arch
+                architecture of taskotron_item to be tested
+            taskotron_generic_task
+                whether to run a generic or STI task
+            taskotron_item_type
+                item under test
+            taskotron_item
+                item type under test
+            taskotron_keepalive_minutes
+                how long should heartbeat process run (0 to disable)
+            taskotron_match_host_arch
+                whether VM guest arch has to match taskotron_arch
+            taskotron_match_host_distro
+                whether VM guest distro has to match taskotron_item
+            taskotron_match_host_release
+                whether VM guest release has to match taskotron_item
+            taskotron_supported_arches
+                list of base architectures supported by Taskotron (e.g.
+                'armhfp')
+            taskotron_supported_binary_arches
+                list of base+binary architectures supported by Taskotron (e.g.
+                'armhfp, armv7hl')
+            test_playbook
+                path to playbook to execute inside client_taskdir (usually
+                tests.yml)
+            varsfile
+                name of the ansible vars file inside ``artifacts/taskotron/``
+                to forward to task
         '''
 
         vars_ = {}
         cfg = config.get_config()
 
         # default values
+        vars_['become_root'] = True
         vars_['taskotron_generic_task'] = False
         vars_['heartbeat_interval'] = 120
         vars_['taskotron_keepalive_minutes'] = 0
@@ -249,14 +260,8 @@ class Executor(object):
         vars_['varsfile'] = 'task_vars.json'
 
         # load all allowed vars from tests.yml
-        with open(os.path.join(self.arg_data['taskdir'], test_playbook), 'r') \
-        as playbook_file:
-            playbook_yaml = yaml.safe_load(playbook_file.read())
-            # we only consider variables in the first play
-            playbook_vars = playbook_yaml[0].get('vars', {})
-        for var, val in playbook_vars.items():
-            if var in self.ACCEPTED_VARS:
-                vars_[var] = val
+        loaded_vars = self._load_playbook_vars(test_playbook)
+        vars_.update(loaded_vars)
 
         # compute vars
         vars_['artifacts'] = os.path.join(self.arg_data['artifactsdir'],
@@ -296,8 +301,8 @@ class Executor(object):
         :param str test_playbook: name of the playbook, relative to the task
             directory
         :param str ipaddr: IP address of the machine the task will be run on
-        :param dict playbook_vars: vars dict based on
-            :const:`_PLAYBOOK_VARS_TEMPLATE`
+        :param dict playbook_vars: vars dict created by
+            :meth:`_create_playbook_vars`
         :return: stream output of the ansible-playbook command (stdout and
             stderr merged together)
         :rtype: str
@@ -333,9 +338,11 @@ class Executor(object):
             'ansible-playbook', 'runner.yml',
             '--inventory=%s,' % ipaddr,  # the ending comma is important
             '--extra-vars=@%s' % allvarsfile,
-            '--become',
         ]
 
+        if playbook_vars['become_root']:
+            cmd.append('--become')
+
         if self.run_remotely:
             if self.arg_data['ssh_privkey']:
                 cmd.append('--private-key=%s' % self.arg_data['ssh_privkey'])
diff --git a/libtaskotron/ext/disposable/vm.py b/libtaskotron/ext/disposable/vm.py
index 494e795..74aaddf 100644
--- a/libtaskotron/ext/disposable/vm.py
+++ b/libtaskotron/ext/disposable/vm.py
@@ -120,7 +120,7 @@ class TestCloudMachine(object):
                                                "already defined".format(self.instancename))
         return existing_instance
 
-    def prepare(self, distro=None, release=None, flavor=None, arch=None):
+    def prepare(self, distro, release, flavor, arch):
         '''Prepare a virtual machine for running tasks.
         :param str distro: Distro to use in image discovery
         :param str release: Distro's release to use in image discovery
diff --git a/libtaskotron/image_utils.py b/libtaskotron/image_utils.py
index 289bd15..20db606 100644
--- a/libtaskotron/image_utils.py
+++ b/libtaskotron/image_utils.py
@@ -23,8 +23,8 @@ def devise_environment(arg_data, playbook_vars):
 
     :param dict arg_data: parsed command-line arguments (item, type and arch
         are used in this method)
-    :param dict playbook_vars: vars dict based on
-        :const:`executor._PLAYBOOK_VARS_TEMPLATE`
+    :param dict playbook_vars: vars dict created by
+        :meth:`executor._create_playbook_vars`
     :return: dict containing ``distro``, ``release``, ``flavor`` and ``arch``.
         Each either set, or ``None``.
     '''
diff --git a/testing/functest_executor.py b/testing/functest_executor.py
index c71a79b..279b38c 100644
--- a/testing/functest_executor.py
+++ b/testing/functest_executor.py
@@ -8,7 +8,6 @@
 import pytest
 import mock
 import signal
-import yaml
 
 from libtaskotron import executor
 import libtaskotron.exceptions as exc
@@ -42,6 +41,9 @@ class TestExecutor():
             'type': 'koji_build',
             'arch': 'noarch',
             'debug': False,
+            'local': True,
+            'libvirt': False,
+            'ssh': False,
             'ssh_privkey': None,
         }
         self.playbook_name = 'tests.yml'
@@ -49,6 +51,8 @@ class TestExecutor():
         self.playbook.write(PLAYBOOK)
         self.ipaddr = '127.0.0.1'
         self.executor = executor.Executor(self.arg_data)
+        self.playbook_vars = self.executor._create_playbook_vars(
+            self.playbook_name)
 
         monkeypatch.setattr(config, '_config', None)
         self.conf = config.get_config()
@@ -68,11 +72,11 @@ class TestExecutor():
         '''Execute a very simple playbook whether everything works'''
         mock_signal = mock.Mock()
         monkeypatch.setattr(signal, 'signal', mock_signal)
+        # it's non-default, but we can't run the test suite as root
+        self.playbook_vars['become_root'] = False
 
-        # the tradeoff here is that we need to run with root=False
-        # (non-default)
-        output, _ = self.executor._run_playbook(self.playbook_name,
-            self.ipaddr, executor.Playbook_Data(yaml.load(PLAYBOOK)[0]), root=False)
+        output = self.executor._run_playbook(self.playbook_name,
+            self.ipaddr, self.playbook_vars)
         # FIXME: We currently have no idea whether the test playbook passed
         # or failed, because we ignore the inner playbook's exit status. So
         # we can't really verify here whether everything worked ok.
diff --git a/testing/test_executor.py b/testing/test_executor.py
index a5dfbfe..527c68f 100644
--- a/testing/test_executor.py
+++ b/testing/test_executor.py
@@ -40,7 +40,6 @@ PLAYBOOK_STI='''
         msg: This is a sample debug printout from an STI task
 '''
 
-PLAYBOOK_DATA=executor.Playbook_Data(yaml.load(PLAYBOOK)[0])
 
 @pytest.mark.usefixtures('setup')
 class TestExecutor():
@@ -68,6 +67,8 @@ class TestExecutor():
         self.playbook.write(PLAYBOOK)
         self.ipaddr = '127.0.0.1'
         self.executor = executor.Executor(self.arg_data)
+        self.playbook_vars = self.executor._create_playbook_vars(
+            self.playbook_name)
 
         monkeypatch.setattr(config, '_config', None)
         self.conf = config.get_config()
@@ -120,31 +121,25 @@ class TestExecutor():
 
     def test_run_playbook(self, monkeypatch):
         '''A standard invocation of ansible-playbook'''
-        mock_check_syntax = mock.Mock()
-        monkeypatch.setattr(executor.Executor, '_check_playbook_syntax',
-            mock_check_syntax)
         mock_signal = mock.Mock()
         monkeypatch.setattr(signal, 'signal', mock_signal)
         mock_popen = mock.Mock(return_value=('fake output', None))
         monkeypatch.setattr(os_utils, 'popen_rt', mock_popen)
 
-        output, _ = self.executor._run_playbook(self.playbook_name,
-            self.ipaddr, PLAYBOOK_DATA)
+        output = self.executor._run_playbook(self.playbook_name,
+            self.ipaddr, self.playbook_vars)
 
         # must return playbook output
         assert output == 'fake output'
 
-        # must check syntax
-        mock_check_syntax.assert_called_once()
-
         # must mask signals
         assert mock_signal.call_count == 4  # 2 signals masked, then reset
 
         # must export ansible vars
         varsfile = os.path.join(self.artifactsdir.strpath, self.playbook_name,
-            'taskotron', 'ansible_vars.json')
+            'taskotron', 'task_vars.json')
         varsfile_internal = os.path.join(self.artifactsdir.strpath,
-            self.playbook_name, 'taskotron', 'ansible_vars_internal.json')
+            self.playbook_name, 'taskotron', 'internal_vars.json')
         for vf in [varsfile, varsfile_internal]:
             assert os.path.isfile(vf)
             with open(vf, 'r') as f:
@@ -155,16 +150,12 @@ class TestExecutor():
         cmd_args = mock_popen.call_args[0][0]
         assert cmd_args[0] == 'ansible-playbook'
         assert '--inventory={},'.format(self.ipaddr) in cmd_args
-        assert '--extra-vars=@{}'.format(varsfile) in cmd_args
         assert '--extra-vars=@{}'.format(varsfile_internal) in cmd_args
         assert '--become' in cmd_args
         assert '--connection=local' in cmd_args
 
     def test_run_playbook_failed(self, monkeypatch):
         '''Should raise when ansible-playbook fails'''
-        mock_check_syntax = mock.Mock()
-        monkeypatch.setattr(executor.Executor, '_check_playbook_syntax',
-            mock_check_syntax)
         mock_signal = mock.Mock()
         monkeypatch.setattr(signal, 'signal', mock_signal)
         cpe = subprocess.CalledProcessError(returncode=99, cmd='fake')
@@ -172,8 +163,8 @@ class TestExecutor():
         monkeypatch.setattr(os_utils, 'popen_rt', mock_popen)
 
         with pytest.raises(exc.TaskotronError):
-            self.executor._run_playbook(self.playbook_name, self.ipaddr, 
-                PLAYBOOK_DATA)
+            self.executor._run_playbook(self.playbook_name, self.ipaddr,
+                self.playbook_vars)
 
         # must unmask signals even when playbook failed
         assert mock_signal.call_count == 4  # 2 signals masked, then reset
@@ -183,9 +174,6 @@ class TestExecutor():
 
     def test_run_playbook_interrupted(self, monkeypatch):
         '''Should try failsafe stop when interrupted'''
-        mock_check_syntax = mock.Mock()
-        monkeypatch.setattr(executor.Executor, '_check_playbook_syntax',
-            mock_check_syntax)
         mock_signal = mock.Mock()
         monkeypatch.setattr(signal, 'signal', mock_signal)
         error = exc.TaskotronInterruptError(15, 'SIGTERM')
@@ -193,8 +181,8 @@ class TestExecutor():
         monkeypatch.setattr(os_utils, 'popen_rt', mock_popen)
 
         with pytest.raises(exc.TaskotronInterruptError):
-            self.executor._run_playbook(self.playbook_name, self.ipaddr, 
-                PLAYBOOK_DATA)
+            self.executor._run_playbook(self.playbook_name, self.ipaddr,
+                self.playbook_vars)
 
         # must unmask signals even when playbook failed
         assert mock_signal.call_count == 4  # 2 signals masked, then reset
@@ -206,9 +194,6 @@ class TestExecutor():
 
     def test_run_playbook_failsafe_error(self, monkeypatch):
         '''When failsafe stop gives an error, it should be ignored'''
-        mock_check_syntax = mock.Mock()
-        monkeypatch.setattr(executor.Executor, '_check_playbook_syntax',
-            mock_check_syntax)
         mock_signal = mock.Mock()
         monkeypatch.setattr(signal, 'signal', mock_signal)
         error = exc.TaskotronInterruptError(15, 'SIGTERM')
@@ -218,10 +203,70 @@ class TestExecutor():
 
         with pytest.raises(exc.TaskotronInterruptError):
             self.executor._run_playbook(self.playbook_name, self.ipaddr,
-                PLAYBOOK_DATA)
+                self.playbook_vars)
+
+    def test_run_playbook_forwarded_vars(self, monkeypatch):
+        '''Only certain vars should get forwarded to task playbook, no other'''
+        mock_signal = mock.Mock()
+        monkeypatch.setattr(signal, 'signal', mock_signal)
+        mock_popen = mock.Mock(return_value=('fake output', None))
+        monkeypatch.setattr(os_utils, 'popen_rt', mock_popen)
+
+        self.executor._run_playbook(self.playbook_name,
+            self.ipaddr, self.playbook_vars)
+        varsfile = os.path.join(self.artifactsdir.strpath, self.playbook_name,
+            'taskotron', 'task_vars.json')
+
+        assert os.path.isfile(varsfile)
+        with open(varsfile, 'r') as vf:
+            vars_ = json.load(vf)
+
+        for var in executor.Executor.FORWARDED_VARS:
+            assert var in vars_
+        assert len(vars_) == len(executor.Executor.FORWARDED_VARS)
+
+    def test_get_client_ipaddr_local(self):
+        '''Local execution'''
+        self.arg_data['local'] = True
+        self.arg_data['libvirt'] = False
+        self.arg_data['ssh'] = False
+        self.executor = executor.Executor(self.arg_data)
+
+        ipaddr = self.executor._get_client_ipaddr()
+
+        assert ipaddr == '127.0.0.1'
+        assert self.executor.run_remotely == False
+
+    def test_get_client_ipaddr_libvirt(self):
+        '''Libvirt execution'''
+        self.arg_data['local'] = False
+        self.arg_data['libvirt'] = True
+        self.arg_data['ssh'] = False
+        self.executor = executor.Executor(self.arg_data)
+
+        ipaddr = self.executor._get_client_ipaddr()
+
+        assert ipaddr == None
+        assert self.executor.run_remotely == True
+
+    def test_get_client_ipaddr_ssh(self):
+        '''Ssh execution'''
+        self.arg_data['local'] = False
+        self.arg_data['libvirt'] = False
+        self.arg_data['ssh'] = True
+        self.arg_data['machine'] = '127.0.0.2'
+        self.executor = executor.Executor(self.arg_data)
+
+        ipaddr = self.executor._get_client_ipaddr()
+
+        assert ipaddr == '127.0.0.2'
+        assert self.executor.run_remotely == True
 
     def test_execute_local(self, monkeypatch):
         '''Execution using local mode'''
+        mock_check_syntax = mock.Mock()
+        monkeypatch.setattr(executor.Executor, '_check_playbook_syntax',
+            mock_check_syntax)
         mock_spawn_vm = mock.Mock()
         monkeypatch.setattr(executor.Executor, '_spawn_vm', mock_spawn_vm)
         mock_run_playbook = mock.Mock(return_value=(None, True))
@@ -230,11 +275,13 @@ class TestExecutor():
         mock_report_results = mock.Mock()
         monkeypatch.setattr(executor.Executor, '_report_results',
             mock_report_results)
-        assert self.executor.arg_data['local'] == True
+        self.executor.ipaddr = '127.0.0.1'
+        self.executor.run_remotely = False
 
         success = self.executor.execute()
 
         assert success == True
+        mock_check_syntax.assert_called_once()
         mock_spawn_vm.assert_not_called()
         mock_run_playbook.assert_called_once()
         assert mock_run_playbook.call_args[0][1] == '127.0.0.1'
@@ -242,6 +289,9 @@ class TestExecutor():
 
     def test_execute_ssh(self, monkeypatch):
         '''Execution using ssh mode'''
+        mock_check_syntax = mock.Mock()
+        monkeypatch.setattr(executor.Executor, '_check_playbook_syntax',
+            mock_check_syntax)
         mock_spawn_vm = mock.Mock()
         monkeypatch.setattr(executor.Executor, '_spawn_vm', mock_spawn_vm)
         mock_run_playbook = mock.Mock(return_value=(None, True))
@@ -250,13 +300,13 @@ class TestExecutor():
         mock_report_results = mock.Mock()
         monkeypatch.setattr(executor.Executor, '_report_results',
             mock_report_results)
-        self.executor.arg_data['local'] = False
-        self.executor.arg_data['ssh'] = True
-        self.executor.arg_data['machine'] = '127.0.0.2'
+        self.executor.ipaddr = '127.0.0.2'
+        self.executor.run_remotely = True
 
         success = self.executor.execute()
 
         assert success == True
+        mock_check_syntax.assert_called_once()
         mock_spawn_vm.assert_not_called()
         mock_run_playbook.assert_called_once()
         assert mock_run_playbook.call_args[0][1] == '127.0.0.2'
@@ -264,6 +314,9 @@ class TestExecutor():
 
     def test_execute_libvirt(self, monkeypatch):
         '''Execution using libvirt mode'''
+        mock_check_syntax = mock.Mock()
+        monkeypatch.setattr(executor.Executor, '_check_playbook_syntax',
+            mock_check_syntax)
         mock_spawn_vm = mock.Mock(return_value='127.0.0.3')
         monkeypatch.setattr(executor.Executor, '_spawn_vm', mock_spawn_vm)
         mock_run_playbook = mock.Mock(return_value=(None, True))
@@ -274,12 +327,13 @@ class TestExecutor():
             mock_report_results)
         mock_task_vm = mock.Mock()
         self.executor.task_vm = mock_task_vm
-        self.executor.arg_data['local'] = False
-        self.executor.arg_data['libvirt'] = True
+        self.executor.ipaddr = None
+        self.executor.run_remotely = True
 
         success = self.executor.execute()
 
         assert success == True
+        mock_check_syntax.assert_called_once()
         mock_spawn_vm.assert_called_once()
         mock_run_playbook.assert_called_once()
         assert mock_run_playbook.call_args[0][1] == '127.0.0.3'
@@ -288,6 +342,9 @@ class TestExecutor():
 
     def test_execute_no_playbooks(self, monkeypatch):
         '''Should raise when there are no playbooks'''
+        mock_check_syntax = mock.Mock()
+        monkeypatch.setattr(executor.Executor, '_check_playbook_syntax',
+            mock_check_syntax)
         mock_run_playbook = mock.Mock()
         monkeypatch.setattr(executor.Executor, '_run_playbook',
             mock_run_playbook)
@@ -299,11 +356,15 @@ class TestExecutor():
         with pytest.raises(exc.TaskotronError):
             self.executor.execute()
 
+        mock_check_syntax.assert_not_called()
         mock_run_playbook.assert_not_called()
         mock_report_results.assert_not_called()
 
     def test_execute_more_playbooks(self, monkeypatch):
         '''Should execute all found playbooks'''
+        mock_check_syntax = mock.Mock()
+        monkeypatch.setattr(executor.Executor, '_check_playbook_syntax',
+            mock_check_syntax)
         mock_run_playbook = mock.Mock(return_value=(None, True))
         monkeypatch.setattr(executor.Executor, '_run_playbook',
             mock_run_playbook)
@@ -315,6 +376,7 @@ class TestExecutor():
         success = self.executor.execute()
 
         assert success == True
+        assert mock_check_syntax.call_count == 2
         assert mock_run_playbook.call_count == 2
         playbooks = [
             mock_run_playbook.call_args_list[0][0][0],
@@ -332,6 +394,9 @@ class TestExecutor():
 
     def test_execute_error(self, monkeypatch):
         '''Should raise on playbook errors'''
+        mock_check_syntax = mock.Mock()
+        monkeypatch.setattr(executor.Executor, '_check_playbook_syntax',
+            mock_check_syntax)
         mock_run_playbook = mock.Mock(side_effect=exc.TaskotronError)
         monkeypatch.setattr(executor.Executor, '_run_playbook',
             mock_run_playbook)
@@ -342,11 +407,15 @@ class TestExecutor():
         success = self.executor.execute()
 
         assert success == False
+        mock_check_syntax.assert_called_once()
         mock_run_playbook.assert_called_once()
         mock_report_results.assert_not_called()
 
     def test_execute_more_playbooks_error(self, monkeypatch):
         '''Should execute all found playbooks even if some has error'''
+        mock_check_syntax = mock.Mock()
+        monkeypatch.setattr(executor.Executor, '_check_playbook_syntax',
+            mock_check_syntax)
         mock_run_playbook = mock.Mock(side_effect=[
             exc.TaskotronError,
             (None, True)])
@@ -360,6 +429,7 @@ class TestExecutor():
         success = self.executor.execute()
 
         assert success == False
+        assert mock_check_syntax.call_count == 2
         assert mock_run_playbook.call_count == 2
         playbooks = [
             mock_run_playbook.call_args_list[0][0][0],
@@ -376,6 +446,9 @@ class TestExecutor():
     def test_execute_sti_no_report(self, monkeypatch):
         '''Shouldn't try to report results for STI tasks'''
         self.playbook.write(PLAYBOOK_STI)
+        mock_check_syntax = mock.Mock()
+        monkeypatch.setattr(executor.Executor, '_check_playbook_syntax',
+            mock_check_syntax)
         mock_spawn_vm = mock.Mock()
         monkeypatch.setattr(executor.Executor, '_spawn_vm', mock_spawn_vm)
         mock_run_playbook = mock.Mock(return_value=(None, False))
@@ -388,6 +461,7 @@ class TestExecutor():
         success = self.executor.execute()
 
         assert success == True
+        mock_check_syntax.assert_called_once()
         mock_spawn_vm.assert_not_called()
         mock_run_playbook.assert_called_once()
         assert mock_run_playbook.call_args[0][1] == '127.0.0.1'
@@ -395,6 +469,9 @@ class TestExecutor():
 
     def test_execute_interrupted(self, monkeypatch):
         '''Should halt execution and return when interrupted'''
+        mock_check_syntax = mock.Mock()
+        monkeypatch.setattr(executor.Executor, '_check_playbook_syntax',
+            mock_check_syntax)
         error = exc.TaskotronInterruptError(15, 'SIGTERM')
         mock_run_playbook = mock.Mock(side_effect=error)
         monkeypatch.setattr(executor.Executor, '_run_playbook',
@@ -407,6 +484,7 @@ class TestExecutor():
         success = self.executor.execute()
 
         assert success == False
+        mock_check_syntax.assert_called_once()
         mock_run_playbook.assert_called_once()
         mock_report_results.assert_not_called()
 
@@ -421,7 +499,7 @@ class TestExecutor():
         vm_instance.ipaddr = '10.11.12.13'
         monkeypatch.setattr(vm, 'TestCloudMachine', mock_vm)
 
-        ipaddr = self.executor._spawn_vm(None, PLAYBOOK_DATA)
+        ipaddr = self.executor._spawn_vm(None, self.playbook_vars)
         assert ipaddr == '10.11.12.13'
         assert mock_vm_prepare.call_count == 2
 
@@ -433,6 +511,28 @@ class TestExecutor():
         monkeypatch.setattr(vm, 'TestCloudMachine', mock_vm)
 
         with pytest.raises(exc.TaskotronMinionError):
-            self.executor._spawn_vm(None, PLAYBOOK_DATA)
+            self.executor._spawn_vm(None, self.playbook_vars)
 
         assert mock_vm_prepare.call_count == self.conf.spawn_vm_retries
+
+    def test_load_playbook_accepted_vars(self):
+        '''All accepted vars must be loaded and none other'''
+        playbook = yaml.safe_load(PLAYBOOK)[0]
+        playbook['vars'].clear()
+        # add all accepted
+        for var in executor.Executor.ACCEPTED_VARS:
+            playbook['vars'][var] = 'This is ' + var
+        # add unaccepted starting with taskotron_
+        playbook['vars']['taskotron_unaccepted'] = 'ignore me'
+        # add unaccepted generic
+        playbook['vars']['unaccepted'] = 'ignore me'
+        self.playbook.remove()
+        self.playbook.write(yaml.safe_dump([playbook]))
+
+        vars_ = self.executor._load_playbook_vars(self.playbook_name)
+
+        for var in executor.Executor.ACCEPTED_VARS:
+            assert var in vars_
+        assert 'taskotron_unaccepted' not in vars_
+        assert 'unaccepted' not in vars_
+        assert len(vars_) == len(executor.Executor.ACCEPTED_VARS)
